'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _require = require('./query'),
    getFilterPredicate = _require.getFilterPredicate;

var withExporters = function withExporters(Base) {
  return function (_Base) {
    _inherits(_class, _Base);

    function _class() {
      _classCallCheck(this, _class);

      return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
    }

    _createClass(_class, [{
      key: 'get',
      value: function get(expression) {
        if (typeof expression === 'string') this.manager.get(expression);

        return expression ? this.filter(expression).first() : this.first();
      }
    }, {
      key: 'count',
      value: function count() {
        return this.toArray().length;
      }
    }, {
      key: 'toArray',
      value: function toArray() {
        return this.map(function (entry) {
          return entry;
        });
      }
    }, {
      key: 'first',
      value: function first() {
        var values = this.values.first();
        return values ? this.manager.build(values) : null;
      }
    }, {
      key: 'last',
      value: function last() {
        var array = this.toArray();
        return array[array.length - 1];
      }
    }, {
      key: 'map',
      value: function map(predicate) {
        return this.reduce(function (array, entry, index) {
          return array.concat([predicate(entry, index)]);
        }, []);
      }
    }, {
      key: 'every',
      value: function every(expression) {
        var predicate = getFilterPredicate(expression);

        return this.reduce(function (result, entry, index) {
          return result && predicate(entry, index);
        }, true);
      }
    }, {
      key: 'some',
      value: function some(expression) {
        var predicate = getFilterPredicate(expression);

        return this.reduce(function (result, entry, index) {
          return result || predicate(entry, index);
        }, false);
      }
    }, {
      key: 'any',
      value: function any(expression) {
        return this.some(expression);
      }
    }, {
      key: 'length',
      get: function get() {
        return this.count();
      }
    }]);

    return _class;
  }(Base);
};

module.exports = {
  withExporters: withExporters
};
