'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('./model'),
    createEntryMixin = _require.createEntryMixin,
    mix = _require.mix;

var usingFieldAccessors = function usingFieldAccessors(name, spec) {
  return createEntryMixin(function (_ref) {
    var Base = _ref.Base;

    var EntryMixin = function (_Base) {
      (0, _inherits3.default)(EntryMixin, _Base);

      function EntryMixin() {
        (0, _classCallCheck3.default)(this, EntryMixin);
        return (0, _possibleConstructorReturn3.default)(this, (EntryMixin.__proto__ || Object.getPrototypeOf(EntryMixin)).apply(this, arguments));
      }

      return EntryMixin;
    }(Base);

    Object.defineProperty(EntryMixin.prototype, name, Object.assign({
      enumerable: true
    }, spec));

    return EntryMixin;
  });
};

var usingFieldInitial = function usingFieldInitial(name, initial) {
  return createEntryMixin(function (_ref2) {
    var Base = _ref2.Base;
    return function (_Base2) {
      (0, _inherits3.default)(_class, _Base2);

      function _class() {
        var _ref3;

        (0, _classCallCheck3.default)(this, _class);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var _this2 = (0, _possibleConstructorReturn3.default)(this, (_ref3 = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref3, [this].concat(args)));

        if (!_this2.values.has(name)) _this2[name] = initial;
        return _this2;
      }

      return _class;
    }(Base);
  });
};

var usingDefaultFieldAccessors = function usingDefaultFieldAccessors(name) {
  return usingFieldAccessors(name, {
    get: function get() {
      return this.values.get(name);
    },
    set: function set(value) {
      this.values = this.values.set(name, value);
    }
  });
};

var withInitializedField = function withInitializedField(name, _ref4) {
  var _ref4$initial = _ref4.initial,
      initial = _ref4$initial === undefined ? null : _ref4$initial;
  return mix([usingFieldInitial(name, initial), usingDefaultFieldAccessors(name)]);
};

var withField = function withField(name) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return withInitializedField(name, options);
};

module.exports = {
  withField: withField
};
