'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Immutable = require('immutable');
var assert = require('assert');

var NO_VALUES = '\n  Trying to build entry without values.\n'.trim();

var NO_TRANSACTION = '\n  Trying to change model without a transaction.\n  Make sure you are inside an action.\n'.trim();

var createObjectManagerConstructor = function createObjectManagerConstructor(QuerySetConstructor) {
  return function (_QuerySetConstructor) {
    (0, _inherits3.default)(_class, _QuerySetConstructor);

    function _class(_ref) {
      var setup = _ref.setup,
          values = _ref.values,
          _ref$transaction = _ref.transaction,
          transaction = _ref$transaction === undefined ? null : _ref$transaction;
      (0, _classCallCheck3.default)(this, _class);

      var _this = (0, _possibleConstructorReturn3.default)(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, { QuerySetConstructor: QuerySetConstructor, values: values }));

      _this.manager = _this;
      _this.transaction = transaction;
      _this.setup = setup;
      return _this;
    }

    (0, _createClass3.default)(_class, [{
      key: 'build',
      value: function build() {
        var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Immutable.Map();

        assert.ok(values && values instanceof Immutable.Map, NO_VALUES);

        var EntryConstructor = this.setup.get('EntryConstructor');
        return new EntryConstructor({ values: values, manager: this, setup: this.setup });
      }
    }, {
      key: 'get',
      value: function get(expression) {
        return typeof expression === 'string' ? this.build(this.values.get(expression)) : (0, _get3.default)(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'get', this).call(this, expression);
      }
    }, {
      key: 'create',
      value: function create() {
        var rawValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var entry = this.build();

        entry.save();
        entry.update(rawValues);

        return entry;
      }
    }, {
      key: 'getOrCreate',
      value: function getOrCreate(expression) {
        return this.get(expression) || this.create(expression);
      }
    }, {
      key: 'sync',
      value: function sync(values) {
        assert.ok(this.transaction, NO_TRANSACTION);
        return this.transaction.sync(values);
      }
    }, {
      key: 'unsync',
      value: function unsync(values) {
        assert.ok(this.transaction, NO_TRANSACTION);
        return this.transaction.unsync(values);
      }
    }]);
    return _class;
  }(QuerySetConstructor);
};

module.exports = {
  createObjectManagerConstructor: createObjectManagerConstructor
};
