"use strict";

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ActionPool = function () {
  function ActionPool() {
    (0, _classCallCheck3.default)(this, ActionPool);

    this.delegations = [];
  }

  (0, _createClass3.default)(ActionPool, [{
    key: "addDelegation",
    value: function addDelegation(action, resolve, reject) {
      this.delegations.push({ action: action, resolve: resolve, reject: reject });
      return this.delegations.length === 1 ? this.runNext() : null;
    }
  }, {
    key: "delegate",
    value: function delegate(action) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        return _this.addDelegation(action, resolve, reject);
      });
    }
  }, {
    key: "onActionResolved",
    value: function onActionResolved(resolve, res) {
      resolve(res);
      this.onActionDone();
    }
  }, {
    key: "onActionRejected",
    value: function onActionRejected(reject, error) {
      reject(error);
      this.onActionDone();
    }
  }, {
    key: "onActionDone",
    value: function onActionDone() {
      this.delegations.shift();
      this.runNext();
    }
  }, {
    key: "runAction",
    value: function runAction(_ref) {
      var _this2 = this;

      var action = _ref.action,
          resolve = _ref.resolve,
          reject = _ref.reject;

      return action().catch(function (error) {
        return _this2.onActionRejected(reject, error);
      }).then(function (res) {
        return _this2.onActionResolved(resolve, res);
      });
    }
  }, {
    key: "runNext",
    value: function runNext() {
      return this.delegations.length > 0 ? this.runAction(this.delegations[0]) : null;
    }
  }, {
    key: "empty",
    get: function get() {
      return this.delegations.length === 0;
    }
  }]);
  return ActionPool;
}();

var createActionPool = function createActionPool() {
  return new ActionPool();
};

module.exports = {
  ActionPool: ActionPool,
  createActionPool: createActionPool
};
