'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var sortBy = require('sort-by');

/*
 * Filter
 */

var createFilterPredicate = function createFilterPredicate(expression) {
  return function (entry) {
    return Object.keys(expression).every(function (key) {
      return entry[key] === expression[key];
    });
  };
};

var getFilterPredicate = function getFilterPredicate(expression) {
  return typeof expression === 'function' ? expression : createFilterPredicate(expression);
};

/*
 * Exclude
 */

var createExcludePredicate = function createExcludePredicate(expression) {
  return function (entry) {
    return Object.keys(expression).every(function (key) {
      return entry[key] !== expression[key];
    });
  };
};

var getExcludePredicate = function getExcludePredicate(expression) {
  return typeof expression === 'function' ? expression : createExcludePredicate(expression);
};

/*
 * Mixin
 */

var withQueries = function withQueries(QuerySetBase) {
  return function (_QuerySetBase) {
    _inherits(_class, _QuerySetBase);

    function _class() {
      _classCallCheck(this, _class);

      return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
    }

    _createClass(_class, [{
      key: 'filter',
      value: function filter(expression) {
        var _this2 = this;

        var predicate = getFilterPredicate(expression);

        return this.subset({
          values: this.values.filter(function (values, index) {
            return predicate(_this2.manager.build(values), index);
          })
        });
      }
    }, {
      key: 'exclude',
      value: function exclude(expression) {
        var _this3 = this;

        var predicate = getExcludePredicate(expression);

        return this.subset({
          values: this.values.filter(function (values, index) {
            return predicate(_this3.manager.build(values), index);
          })
        });
      }
    }, {
      key: 'sort',
      value: function sort(predicate) {
        var _this4 = this;

        return this.subset({
          values: this.values.sort(function (values1, values2) {
            return predicate(_this4.manager.build(values1), _this4.manager.build(values2));
          })
        });
      }
    }, {
      key: 'reverse',
      value: function reverse() {
        return this.subset({ values: this.values.reverse() });
      }
    }, {
      key: 'orderBy',
      value: function orderBy() {
        var sortComparator = sortBy.apply(undefined, arguments);

        return this.sort(sortComparator);
      }
    }, {
      key: 'all',
      value: function all() {
        return this.clone();
      }
    }]);

    return _class;
  }(QuerySetBase);
};

module.exports = {
  withQueries: withQueries,
  getFilterPredicate: getFilterPredicate,
  getExcludePredicate: getExcludePredicate
};
