'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var assert = require('assert');

var _require = require('./query'),
    withQueries = _require.withQueries;

var _require2 = require('./export'),
    withExporters = _require2.withExporters;

var QuerySetBase = function () {
  _createClass(QuerySetBase, null, [{
    key: 'extractValues',
    value: function extractValues(_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          values = _ref2[1];

      return values;
    }
  }]);

  function QuerySetBase(_ref3) {
    var QuerySetConstructor = _ref3.QuerySetConstructor,
        values = _ref3.values,
        manager = _ref3.manager;

    _classCallCheck(this, QuerySetBase);

    assert.ok(values, 'Trying to create a queryset without values');

    this.QuerySetConstructor = QuerySetConstructor;
    this.manager = manager;
    this.values = values;
  }

  _createClass(QuerySetBase, [{
    key: 'forEach',
    value: function forEach(predicate) {
      var _this = this;

      this.values.forEach(function (values, index) {
        return predicate(_this.manager.build(values), index);
      });
    }
  }, {
    key: 'reduce',
    value: function reduce(predicate) {
      var _this2 = this;

      var initial = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      return this.values.reduce(function (memo, values, index) {
        var entry = _this2.manager.build(values);

        return predicate(memo, entry, index);
      }, initial);
    }
  }, {
    key: 'update',
    value: function update(rawValues) {
      return this.reduce(function (res, entry) {
        return res && entry.update(rawValues);
      }, true);
    }
  }, {
    key: 'delete',
    value: function _delete() {
      return this.reduce(function (res, entry) {
        return res && entry.delete();
      }, true);
    }
  }, {
    key: 'clone',
    value: function clone() {
      return this.subset({});
    }
  }, {
    key: 'subset',
    value: function subset(_ref4) {
      var _ref4$values = _ref4.values,
          values = _ref4$values === undefined ? this.values : _ref4$values,
          _ref4$manager = _ref4.manager,
          manager = _ref4$manager === undefined ? this.manager : _ref4$manager,
          _ref4$QuerySetConstru = _ref4.QuerySetConstructor,
          QuerySetConstructor = _ref4$QuerySetConstru === undefined ? this.QuerySetConstructor : _ref4$QuerySetConstru;

      return new QuerySetConstructor({
        values: values,
        manager: manager,
        QuerySetConstructor: QuerySetConstructor
      });
    }
  }]);

  return QuerySetBase;
}();

var QuerySetWithQueries = withQueries(QuerySetBase);
var QuerySetWithExporters = withExporters(QuerySetWithQueries);

var QuerySet = function (_QuerySetWithExporter) {
  _inherits(QuerySet, _QuerySetWithExporter);

  function QuerySet(_ref5) {
    var _ref5$QuerySetConstru = _ref5.QuerySetConstructor,
        QuerySetConstructor = _ref5$QuerySetConstru === undefined ? QuerySet : _ref5$QuerySetConstru,
        values = _ref5.values,
        manager = _ref5.manager;

    _classCallCheck(this, QuerySet);

    return _possibleConstructorReturn(this, (QuerySet.__proto__ || Object.getPrototypeOf(QuerySet)).call(this, { QuerySetConstructor: QuerySetConstructor, values: values, manager: manager }));
  }

  return QuerySet;
}(QuerySetWithExporters);

module.exports = {
  QuerySet: QuerySet
};
